List a user's memberships (direct and transitive)
Namespace: microsoft.graph
Important
APIs under the /beta version in Microsoft Graph are subject to change. Use of these APIs in production applications is not supported. To determine whether an API is available in v1.0, use the Version selector.
Get groups, directory roles, and administrative units that the user is a member of through either direct or transitive membership.
Permissions
One of the following permissions is required to call this API. To learn more, including how to choose permissions, see Permissions.
| Permission type | Permissions (from least to most privileged) |
|---|---|
| Delegated (work or school account) | User.Read, GroupMember.Read.All, Directory.Read.All, Directory.ReadWrite.All |
| Delegated (personal Microsoft account) | Not supported. |
| Application | Directory.Read.All, Directory.ReadWrite.All |
HTTP request
GET /users/{id | userPrincipalName}/transitiveMemberOf
Optional query parameters
This method supports the OData query parameters to help customize the response, including $search, $count, and $filter. OData cast is also enabled, for example, you can cast to get just the transitive membership in groups. You can use $search on the displayName property. When items are added or updated for this resource, they are specially indexed for use with the $count and $search query parameters. There can be a slight delay between when an item is added or updated and when it is available in the index.
Request headers
| Header | Value |
|---|---|
| Authorization | Bearer {token}. Required. |
| ConsistencyLevel | eventual. This header and $count are required when using the $search, $filter, $orderby, or OData cast query parameters. It uses an index that might not be up-to-date with recent changes to the object. |
Request body
Do not supply a request body for this method.
Response
If successful, this method returns a 200 OK response code and collection of directoryObject objects in the response body.
Examples
Example 1: Get groups, directory roles, and administrative units that the user is a member of
Request
Here is an example of the request.
GET https://graph.microsoft.com/beta/users/{id}/transitiveMemberOf
Response
The following is an example of the response.
Note: The response object shown here might be shortened for readability.
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context":"https://graph.microsoft.com/beta/$metadata#directoryObjects",
"value":[
{
"@odata.type":"#microsoft.graph.group",
"displayName":"All_Contoso_Licensing",
"mailEnabled":true,
"mailNickname":"ContosoMailNickName",
"securityEnabled":true
},
{
"@odata.type":"#microsoft.graph.group",
"displayName":"ContosoAudience_PugetSound",
"mailEnabled":true,
"mailNickname":"Contoso_PugetSound",
"securityEnabled":true
}
]
}
Example 2: Get only a count of transitive membership in groups, directory roles, and administrative units
Request
The following is an example of the request.
GET https://graph.microsoft.com/beta/users/{id}/transitiveMemberOf/$count
ConsistencyLevel: eventual
Response
The following is an example of the response.
HTTP/1.1 200 OK
Content-type: text/plain
893
Example 3: Use OData cast to get only a count of transitive membership in groups
Request
The following is an example of the request.
GET https://graph.microsoft.com/beta/users/{id}/transitiveMemberOf/microsoft.graph.group/$count
ConsistencyLevel: eventual
Response
The following is an example of the response.
HTTP/1.1 200 OK
Content-type: text/plain
588
Example 4: Use $search and OData cast to get transitive membership in groups with display names that contain the letters 'tier' including a count of returned objects
Request
The following is an example of the request.
GET https://graph.microsoft.com/beta/users/{id}/transitiveMemberOf/microsoft.graph.group?$count=true&$orderby=displayName&$search="displayName:tier"&$select=displayName,id
ConsistencyLevel: eventual
Response
The following is an example of the response.
Note: The response object shown here might be shortened for readability.
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context":"https://graph.microsoft.com/beta/$metadata#groups(displayName,id)",
"@odata.count":7,
"value":[
{
"displayName":"Contoso-tier Query Notification",
"id":"11111111-2222-3333-4444-555555555555"
}
]
}
Example 5: Use $filter and OData cast to get transitive membership in groups with a display name that starts with 'a' including a count of returned objects
Request
The following is an example of the request.
GET https://graph.microsoft.com/beta/users/{id}/transitiveMemberOf/microsoft.graph.group?$count=true&$orderby=displayName&$filter=startswith(displayName, 'a')
ConsistencyLevel: eventual
Response
The following is an example of the response.
Note: The response object shown here might be shortened for readability.
HTTP/1.1 200 OK
Content-type: application/json
{
"@odata.context":"https://graph.microsoft.com/beta/$metadata#groups",
"@odata.count":76,
"value":[
{
"displayName":"AAD Contoso Users",
"mail":"AADContoso_Users@contoso.com",
"mailEnabled":true,
"mailNickname":"AADContoso_Users",
"securityEnabled":true
}
]
}
Feedback
Submit and view feedback for